#!/usr/bin/env python

import sys
import os
from subprocess import Popen, PIPE

def test(files):
    freq_table = [ 8000,11250,12000,16000,22500,24000,
                   32000,44100,48000,64000,88200,96000 ]
    profile_table = 'aac_low aac_he aac_he_v2'.split()
    vbrq_table = [ 1,2,3,4,5 ]

    for profile in profile_table:
        for f in files:
            for freq in freq_table:
                succeeded = []
                for vbrq in vbrq_table:
                    cmd1 = ['refalac','-s','-D','--rate', str(freq), '-o-', f ]
                    p1 = Popen(cmd1, stdout=PIPE)
                    cmd2 = ['avconv','-i','-','-c','libfdk_aac',
                            '-vbr',str(vbrq),'-profile',profile,'tmp.m4a']
                    p2 = Popen(cmd2, stdin=p1.stdout, stdout=PIPE,stderr=PIPE)
                    p1.stdout.close()
                    out, err = p2.communicate()
                    try:
                        os.remove('tmp.m4a')
                    except:
                        pass
                    if p2.returncode == 0:
                        succeeded.append(vbrq)
                if succeeded:
                    name = os.path.splitext(os.path.basename(f))[0]
                    print('%s\t%s\t%d\t%s' % (
                        profile, name, freq, ','.join(map(str,succeeded))))

def main():
    test(sys.argv[1:])

if __name__ == '__main__':
    main()
